/*############################################################################
#                                                                            #
#                      TWI}X^[[h֐                             #
#                                                                            #
#@RpCmFFAtmelStudio 6.1(SP2)                                  #
#                                                                            #
#                                                  2014/02/17 Create by nPYO #
#                                                                            #
##############################################################################
#                                                                            #
#   AVR̓vAbvR𗘗pƒRQ{ȗ\                  #
#     n[hEGAE\tgEGÃ̗[hŗL                         #
#   \tgEGATWȈꍇF_CPU̒`Kv                               #
#                                                                            #
############################################################################*/
#ifndef __TWI_FUNCTION_H__
#define __TWI_FUNCTION_H__

//
// ˑp[^igpɉďj
//
#define TWI_MODE		1			// 0:\tgEGATWI  1:n[hEGATWI
#define TWI_IN_PULLUP	1			// 0:OvAbv   1:vAbv
 
#define TWI_SDA_PIN PINC			// TWI SDA |[g
#define TWI_SDA_BIT PC4				//     SDA rbgԍ

#define TWI_SCL_PIN PINC			// TWI SCL |[g
#define TWI_SCL_BIT PC5				//     SCL rbgԍ

#define TWI_TWBR		2			// {[[gWFl[^̐ݒl F = F_CPU / ( ( TWI_TWBR * 2 ) + 16 )
									// TWI_MODE != 0 ̎L

									// F_CPU = 1MHz̏ꍇ : TWI_TWBR =  2  50KHz

									// F_CPU = 8MHz̏ꍇ : TWI_TWBR =  2  400KHz
									// F_CPU = 8MHz̏ꍇ : TWI_TWBR = 12  200KHz
									// F_CPU = 8MHz̏ꍇ : TWI_TWBR = 32  100KHz

									// F_CPU = 10MHz̏ꍇ : TWI_TWBR =  2  500KHz
									// F_CPU = 10MHz̏ꍇ : TWI_TWBR = 17  200KHz
									// F_CPU = 10MHz̏ꍇ : TWI_TWBR = 42  100KHz

									// F_CPU = 16MHz̏ꍇ : TWI_TWBR =  2  800KHz
									// F_CPU = 16MHz̏ꍇ : TWI_TWBR =  8  500KHz
									// F_CPU = 16MHz̏ꍇ : TWI_TWBR = 12  400KHz
									// F_CPU = 16MHz̏ꍇ : TWI_TWBR = 32  200KHz
									// F_CPU = 16MHz̏ꍇ : TWI_TWBR = 72  100KHz
//
// ͏sv
//

#ifndef F_CPU
#error not defined symbol 'F_CPU'
#endif

#include <avr/io.h>

/* 萔`								*/
#define TWI_ACK  0
#define TWI_NACK 1

#define TWI_WRITE 0x00
#define TWI_READ  0x01

/* ֐vg^Cv錾				*/
uint8_t TWI_read( uint8_t ack );
uint8_t TWI_write( uint8_t data );
void TWI_transferEnd( void );
uint8_t TWI_transferStart( uint8_t addr ,uint8_t mode );
void TWI_init( void );

#endif